﻿/*
*	FILE			: ESMIS_ADMIN.cs
*	PROJECT			: ESMIS
*	PROGRAMMER		: BRIAN HINDS
*	FIRST VERSION	: 1.0.0
*	DESCRIPTION 	: Admin application for the ESMIS software
*/
using System;
using System.Windows.Forms;

namespace ESMIS
{
    public partial class ESMIS_ADMIN : Form
    {
        private string esmisHours;
        private const string semestermonths = "2920, 0, 0, 0";
        private const string semesteryear = "5840, 0, 0, 0";
        private string semesterSeason;
        private ESMIS_LOG logUser = new ESMIS_LOG();

        public ESMIS_ADMIN()
        {
            InitializeComponent();
            logUser.user_log("Administrator login successfully");
        }

        /*
        *DISCRIPTION:  Length of game check button.
        */

        private void year_Button_CheckedChanged(object sender, EventArgs e)
        {
            if (year_Button.Checked)
            {
                fall_Button.Enabled = false;
                winter_Button.Enabled = false;
                fall_Button.Checked = false;
                winter_Button.Checked = false;
            }
        }

        /*
      *DISCRIPTION:  Semester season for the semester option.
      */

        private void semester_Button_CheckedChanged(object sender, EventArgs e)
        {
            if (semester_Button.Checked)
            {
                fall_Button.Enabled = true;
                winter_Button.Enabled = true;
            }
        }

        /*
     *  FUNCTION       : smis_session()
     *  DISCRIPTION    : Add the timespan to the current session
     *  PARAMETER      : None
     *  RETURN         : DateTime
     */

        public DateTime esmis_session()
        {
            if (semester_Button.Checked)
            {
                esmisHours = semestermonths;
                if (winter_Button.Checked) { semesterSeason = "WINTER"; }
                if (fall_Button.Checked) { semesterSeason = "FALL"; }
            }
            if (year_Button.Checked)
            {
                esmisHours = semesteryear;
            }

            DateTime currentSession = DateTime.Now;
            TimeSpan time = new TimeSpan(Int64.Parse(esmisHours));
            DateTime newSession = currentSession.Add(time);

            return newSession;
        }
    }
}