﻿/*
*	FILE			: ESMIS_LOG.cs
*	PROJECT			: ESMIS
*	PROGRAMMER		: BRIAN HINDS, JAMES SIMPSOM, JACKSON RUBY
*	FIRST VERSION	: 1.0.0
*	DESCRIPTION 	: This class logs events during application use.
*/
using System;
using System.IO;

namespace ESMIS
{
    internal class ESMIS_LOG
    {
        private string session_log = "";
        private string path = "SessionLog.txt";
        private char[] delimter = { '\n' };

        /*
       *  FUNCTION       : user_log
       *  DISCRIPTION    : Logs current session activity
       *  PARAMETER      : string log
       *  RETURN         : None
       */

        public void user_log(string log)
        {
            session_log += "\n " + DateTime.Now.ToString(@"mm\/dd\/yyyy h\:mm:ss tt ") + log;
            save_log();
        }

        /*
       *  FUNCTION       : save_log()
       *  DISCRIPTION    : Save current session log
       *  PARAMETER      : None
       *  RETURN         : string
       */

        public void save_log()
        {
            // This text is added only once to the file.
            if (!File.Exists(path))
            {
                // Create a file to write to.
                using (StreamWriter saveLog = File.CreateText(path))
                {
                    string[] theLog = session_log.Split(delimter);

                    foreach (string l in theLog)
                    {
                        saveLog.WriteLine(l);
                    }
                }
            }

            if (File.Exists(path))
            {
                // This text is always added, making the file longer over time
                // if it is not deleted.
                using (StreamWriter saveLog = File.AppendText(path))
                {
                    string[] theLog = session_log.Split(delimter);

                    foreach (string l in theLog)
                    {
                        saveLog.WriteLine(l);
                    }
                }
            }
        }
    }
}