﻿/*
*	FILE			: ESMIS_LISTEN
*	PROJECT			: ESMIS
*	PROGRAMMER		: BRIAN HINDS, JAMES SIMPSOM, JACKSON RUBY
*	FIRST VERSION	: 1.0.0
*	DESCRIPTION 	: Listen for client's save game data
*/
using System;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace ESMIS_SERVER
{
    public partial class ESMIS_LISTEN : Form
    {
        private ESMIS_DATABASE _DataBase = new ESMIS_DATABASE();
        private string userName = "";
        private string company = "";
        private string stockAmount = "";
        private string transaction = "";
        private string transactionType = "";
        private string transactionDate = "";
        private string bankBalance = "";
        private char delimiter = ',';
        private string SaveData = "";

        public ESMIS_LISTEN()
        {
            InitializeComponent();
        }

        /*
        *  FUNCTION       : serverThread()
        *  DISCRIPTION    : Mini server that receive save data
        *  PARAMETER      : none
        *  RETURN         : none
        */

        public void serverThread()
        {
            UdpClient udpClient = new UdpClient(8000);
            while (true)
            {
                IPEndPoint RemoteIpEndPoint = new IPEndPoint(IPAddress.Any, 0);
                Byte[] receiveBytes = udpClient.Receive(ref RemoteIpEndPoint);
                string returnData = Encoding.ASCII.GetString(receiveBytes);
                SaveData = returnData.ToString();

                if (SaveData.Contains("Client"))
                {
                    userSave(SaveData);
                }
            }
        }

        /*
       *  FUNCTION       : ESMIS_LISTEN_Load
       *  DISCRIPTION    : Start connection
       *  PARAMETER      : (object sender, EventArgs e)
       *  RETURN         : None
       */

        private void ESMIS_LISTEN_Load(object sender, EventArgs e)
        {
            Thread thdUDPServer = new Thread(new
            ThreadStart(serverThread));
            thdUDPServer.Start();
        }

        /*
        *  FUNCTION       : userSave
        *  DISCRIPTION    : Parse user data to be saver
        *  PARAMETER      : string clientData)
        *  RETURN         : None
        */

        public void userSave(string clientData)
        {
            int count = 0;
            string[] substrings = clientData.Split(delimiter);

            foreach (var substring in substrings)
            {
                if (count == 0) { userName = substring; }
                if (count == 1) { company = substring; }
                if (count == 2) { stockAmount = substring; }
                if (count == 3) { transaction = substring; }
                if (count == 4) { transactionType = substring; }
                if (count == 5) { transactionDate = substring; }
                if (count == 6) { bankBalance = substring; }

                count++;
            }
            _DataBase.saveGameSession(userName, company, stockAmount, transaction, transactionDate, transactionType, bankBalance);

            dataTB.Text = count.ToString();
        }
    }
}