﻿/*
*	FILE			: ESMIS_SERVER_PWRES
*	PROJECT			: ESMIS
*	PROGRAMMER		: BRIAN HINDS, JAMES SIMPSOM, JACKSON RUBY
*	FIRST VERSION	: 1.0.0
*	DESCRIPTION 	: Extracts user's password reset data
*/
namespace ESMIS_SERVER
{
    internal class ESMIS_SERVER_PWRES
    {
        private ESMIS_DATABASE _DataBase = new ESMIS_DATABASE();
        /// <summary>
        /// Variables for password reset
        /// </summary>
        private string studentID;       
        private string secretQA;
        private string secretQB;
        private string secretAA;
        private string secretAB;
        private string _hash;
        private string _salt;
        private int count = 0;
        private char delimiter = ',';
        private bool isExist;
        public bool _Confirmation;

        /*
        *  FUNCTION       : userDataExtraction
        *  DISCRIPTION    : Extract user data
        *  PARAMETER      : (string clientData
        *  RETURN         : None
        */

        public void userDataExtraction(string clientData)
        {
            count = 0;
            string[] substrings = clientData.Split(delimiter);

            foreach (var substring in substrings)
            {
                if (count == 0) { studentID = substring; }
                if (count == 1) { secretQA = substring; }
                if (count == 2) { secretQB = substring; }
                if (count == 3) { secretAA = substring; }
                if (count == 4) { secretAB = substring; }

                count++;
            }
            _Confirmation = checkAndConfirm();
        }

        /*
        *  FUNCTION       : checkAndConfirm()
        *  DISCRIPTION    : Checking if the current user exist
        *  PARAMETER      : None
        *  RETURN         : bool isExist
        */

        private bool checkAndConfirm()
        {
            isExist = _DataBase.checkUserChangeRequest(studentID, secretQA, secretQB, secretAA, secretAB);

            return isExist;
        }

        /*
        *  FUNCTION       : userNewDataExtraction
        *  DISCRIPTION    : Extract and Adding new hash and salt for user who passes validation
        *  PARAMETER      : string clientData
        *  RETURN         : none
        */

        public void userNewDataExtraction(string clientData)
        {
            count = 0;
            string[] substrings = clientData.Split(delimiter);

            foreach (var substring in substrings)
            {
                if (count == 0) { studentID = substring; }
                if (count == 1) { _salt = substring; }
                if (count == 2) { _hash = substring; }

                count++;
            }
            _Confirmation = _DataBase.updateUserPasswordData(studentID, _hash, _salt);
        }
    }
}