﻿/*
*	FILE			: ESMIS_SERVER_REG
*	PROJECT			: ESMIS
*	PROGRAMMER		: BRIAN HINDS, JAMES SIMPSOM, JACKSON RUBY
*	FIRST VERSION	: 1.0.0
*	DESCRIPTION 	: Manage the registration process for new user to the data base
*/
namespace ESMIS_SERVER
{
    internal class ESMIS_SERVER_REG
    {
        private ESMIS_DATABASE _DataBase = new ESMIS_DATABASE();
        /// <summary>
        /// Variables for registration data
        /// </summary>
        private string userName;
        private string firstName;       //placeholder for first name
        private string lastName;        //placeholder for last name
        private string studentID;       //placeholder for student ID
        private string _salt;        //placeholder for password
        private string _hash;
        private string instructorCode;  //placeholder for instructor code
        private string courseCode;      //placeholder for course code
        private string instituteCode;       //placeholder for institution
        private string userEmail;        //placeholder for email
        private string secretQA;
        private string secretQB;
        private string secretAA;
        private string secretAB;
        /// <summary>
        /// Variables that determine the registration process
        /// </summary>
        private bool isExist = true;
        public bool _Success;
        private char delimiter = ',';
        private int count = 0;

        /*
        *  FUNCTION       : userRegistration
        *  DISCRIPTION    : Extracting registration data from string array
        *  PARAMETER      : (string clientData)
        *  RETURN         : None
        */

        public void userRegistration(string clientData)
        {
            count = 0;
            string[] substrings = clientData.Split(delimiter);

            foreach (var substring in substrings)
            {
                if (count == 0) { firstName = substring; }
                if (count == 1) { lastName = substring; }
                if (count == 2) { studentID = substring; }
                if (count == 3) { instructorCode = substring; }
                if (count == 4) { courseCode = substring; }
                if (count == 5) { instituteCode = substring; }
                if (count == 6) { userEmail = substring; }
                if (count == 7) { secretQA = substring; }
                if (count == 8) { secretQB = substring; }
                if (count == 9) { secretAA = substring; }
                if (count == 10) { secretAB = substring; }
                if (count == 11) { _salt = substring; }
                if (count == 12) { _hash = substring; }
                count++;
            }
            checkAndInsert();
        }

        /*
        *  FUNCTION       : checkAndInsert()
        *  DISCRIPTION    : Check for existing user then register non user
        *  PARAMETER      : None
        *  RETURN         : bool
        */

        private bool checkAndInsert()
        {

            //creating user name from email address
            char delimiter = '@';
            int count = 0;
            string[] substrings = userEmail.Split(delimiter);
            foreach (var substring in substrings)

                //User name created
                if (count == 0) { userName = substring; count++; }

            //calling database method to add new user
            isExist = _DataBase.checkNewUser(userName);

            if (isExist == false)
            {
                
                _DataBase._AddUser(userName, _salt, _hash, firstName, lastName, studentID, instructorCode, instituteCode, courseCode, userEmail, secretQA, secretQB, secretAA, secretAB);
            }
            return isExist;
        }

        /*
        *  FUNCTION       : _IsRegister()
        *  DISCRIPTION    : Getting registration results
        *  PARAMETER      : None
        *  RETURN         : bool
        */

        public bool _IsRegister()
        {
            _Success = isExist;
            return _Success;
        }
    }
}